import { QueryFilterOperators } from '../common/constants';
export interface QueryFilter {
    field: string;
    operator: QueryFilterOperators;
    value?: any;
}
type QuerySortOperator = 'ASC' | 'DESC';
export interface QueryJoin {
    field: string;
    select?: string[];
}
export interface QuerySort {
    field: string;
    order: QuerySortOperator;
}
type SPrimitivesVal = string | number | boolean;
type SFiledValues = SPrimitivesVal | Array<SPrimitivesVal>;
type SFieldOperator = {
    $eq?: SFiledValues;
    $ne?: SFiledValues;
    $gt?: SFiledValues;
    $lt?: SFiledValues;
    $gte?: SFiledValues;
    $lte?: SFiledValues;
    $starts?: SFiledValues;
    $ends?: SFiledValues;
    $cont?: SFiledValues;
    $excl?: SFiledValues;
    $in?: SFiledValues;
    $notin?: SFiledValues;
    $between?: SFiledValues;
    $isnull?: SFiledValues;
    $notnull?: SFiledValues;
    $eqL?: SFiledValues;
    $neL?: SFiledValues;
    $startsL?: SFiledValues;
    $endsL?: SFiledValues;
    $contL?: SFiledValues;
    $exclL?: SFiledValues;
    $inL?: SFiledValues;
    $notinL?: SFiledValues;
    $or?: SFieldOperator;
    $and?: never;
};
export type SField = SPrimitivesVal | SFieldOperator;
export type SCondition = {
    [key: string]: SField | SCondition[] | undefined;
    $or?: SCondition[];
    $and?: SCondition[];
};
export interface ParsedRequestParams {
    fields: string[];
    paramsFilter: QueryFilter[];
    authPersist?: Record<string, any>;
    search: SCondition;
    filter: QueryFilter[];
    or: QueryFilter[];
    join: QueryJoin[];
    sort: QuerySort[];
    limit?: number;
    offset?: number;
    page?: number;
    cache?: number;
}
export {};
