import { ValidationError } from 'class-validator';
import { ConvertedRequestParam, TargetObject } from '../common/types';
import { GenerateConstraintErrorOptions } from '../interfaces/generate-constraint-error-options.interface';
type ValidationErrorGenerationFunc = (target: TargetObject, propertyName: string, value: any, parentPrefix: string | undefined) => ValidationError;
export declare class NestJSMicroserviceValidationException extends Error {
    readonly messages: string[];
    constructor(messages: string[]);
}
export declare const generatePrefix: (property: string, parentPrefix?: string | undefined, arrayIndex?: number | undefined) => string;
export declare function generateConstraintError(object: ConvertedRequestParam, value: any, options: GenerateConstraintErrorOptions, parentPrefix?: string): ValidationError;
export declare const generateWhitelistError: ValidationErrorGenerationFunc;
export declare const generateWrongJoinError: ValidationErrorGenerationFunc;
export declare const generateNotPrimitiveParamError: ValidationErrorGenerationFunc;
export declare const parseValidationError: (parsedErrors: string[], validationError: ValidationError, parentPrefix?: string) => void;
export declare const parseValidationErrors: (validationErrors: ValidationError[]) => void;
export {};
