import { RelatedDtoOptions } from '../interfaces/related-dto-options.interface';
import { RELATED_DTO_OPTIONS } from '../common/constants';
import { TargetObject } from '../common/types';

/**
 * Decorator that specify dto property as related dto
 * @param options - Related dto options object
 */
export const RelatedDto =
  (options: RelatedDtoOptions = { nestedRelations: [] }): PropertyDecorator =>
  (target: TargetObject, propertyKey: keyof TargetObject) => {
    Reflect.defineMetadata(RELATED_DTO_OPTIONS, options, target, propertyKey);
  };
