import { ValidationError } from 'class-validator';
import { CrudRequestTypes } from '../common/constants';

export interface CreateDtoInstanceOptions {
  /**
   *  Main validation errors array
   */
  validationErrors: ValidationError[];
  /**
   * Is custom dto added?
   */
  isCustomDto?: boolean;
  /**
   * Crud method group
   */
  methodGroup?: CrudRequestTypes;
  /**
   * List of nested fields that are allowed for relations
   */
  nestedRelations?: string[];
  /**
   * Is current dto main one
   */
  isMainDto?: boolean;
  /**
   * Parent prefix for error messages
   */
  parentPropertyPrefix?: string;
}
