import { MicroserviceValidation } from '../../src';
import { TargetObject } from '../../src/common/types';
import { NestedDto } from '../dto/nested.dto';
import { ParsedRequestParams } from '../../src/interfaces/parsed-request-params.interface';

@MicroserviceValidation(NestedDto)
export class ValidateNestedOnlyController {
  createOne(data: { dto: TargetObject }): TargetObject {
    return data.dto;
  }

  getOne(data: { req: TargetObject }): ParsedRequestParams {
    return data.req.parsed;
  }
}
