import { IsString, ValidateNested } from 'class-validator';
import { RelatedDto, CrudRequestTypes } from '../../src';
import { NestedDto } from './nested.dto';

export class DisabledNestedRelationsDto {
  @RelatedDto()
  @ValidateNested({
    context: NestedDto,
    groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ],
  })
  nestedField?: NestedDto;

  @IsString({ groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ] })
  requiredField?: string;
}
