/* eslint-disable no-use-before-define */
import { IsOptional, IsString, ValidateNested } from 'class-validator';
import { RelatedDto, CrudRequestTypes } from '../../src';
import { ValidateIfRelatedOnly } from '../../src/decorators/validate-if-related-only.decorator';

export class NestedDto {
  @RelatedDto()
  @ValidateNested({
    context: NestedDto,
    groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ],
  })
  nestedField?: NestedDto;

  @ValidateIfRelatedOnly({ groups: [CrudRequestTypes.CREATE] })
  @IsString({ groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ] })
  requiredField?: string;

  @ValidateIfRelatedOnly({ groups: [CrudRequestTypes.READ] })
  @IsString({ groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ] })
  @IsOptional({ groups: [CrudRequestTypes.CREATE, CrudRequestTypes.UPDATE, CrudRequestTypes.READ] })
  optionalField?: string;

  @IsString({ groups: [CrudRequestTypes.UPDATE] })
  @IsOptional()
  nestedGroupRelationCheck?: string;
}
