import { IsOptional, IsString, ValidateNested } from 'class-validator';
import { RelatedDto } from '../../src';
import { NestedDto } from './nested.dto';

export class WrongName {
  @RelatedDto({ nestedRelations: [] })
  @ValidateNested({ context: NestedDto })
  nestedField?: NestedDto;

  @IsString()
  requiredField?: string;

  @IsString()
  @IsOptional()
  optionalField?: string;
}
